%
%
%

\section{Garbage collection algorithm}

\subsection{Operations on the roots}

The $\ms{minor\_roots}$ array contains pointers to blocks in the major heap that \emph{may} contain
pointers into the minor heap.  The \thmtitle{Root invariant}~\ref{invariant:roots} requires that
the root bit $R$ is set in the header of each block in $\ms{minor\_roots}$.

The $\ms{clear\_minor\_root}$ function deletes all entries in $\ms{minor\_roots}$, clearing the root
bits $R$ in the process.

\subsection{The mark phase}

The 

\subsection{Garbage collection}

The garbage collector is called with five parameters:

\begin{enumerate}
\item the process context $\ms{contextp}$,
\item the number of heap bytes requested $\ms{req\_bytes}$,
\item the number of free entries in the pointer table requested $\ms{req\_pointers}$,
\item an array of values of the machine registers $\ms{regs}$,
\item and a bitmask of indicating which registers contain pointers.
\end{enumerate}

The $\ms{normalize}$ function converts the value of each register that contain a pointer to its
corresponding index in the pointer table.  The $\ms{denormalize}$ function does the reverse.

% -*-
% Local Variables:
% Mode: LaTeX
% fill-column: 100
% TeX-master: "paper"
% TeX-command-default: "LaTeX/dvips Interactive"
% End:
% -*-
